/*
 * name: database.h
 * description: data base of application
 * author: tilman jochems
 * (c)11/2004, midi-formatique, rivesaltes
 */
#ifndef DataBaseH
#define DataBaseH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Db.hpp>
#include <DBTables.hpp>

//form of buttons
#define ELLIPSE        0
#define RECTANGLE      1

//protocols
#define PROTO_RC5      0
#define PROTO_GRUNDIG  1

class TData : public TDataModule
{
__published:
    TTable *TCodes;
    TDatabase *Database;
    TTable *TRemotes;
    TQuery *QCode;
    TSmallintField *QCodeRemote;
    TSmallintField *QCodeAddress;
    TSmallintField *QCodeCode;
    TStringField *QCodeDescription;
    TSmallintField *QCodeShortCut;
    TSmallintField *QCodeForme;
    TSmallintField *QCodeX;
    TSmallintField *QCodeY;
    TSmallintField *QCodeW;
    TSmallintField *QCodeH;
    TSmallintField *TCodesRemote;
    TSmallintField *TCodesAddress;
    TSmallintField *TCodesCode;
    TStringField *TCodesDescription;
    TSmallintField *TCodesShortCut;
    TSmallintField *TCodesForme;
    TSmallintField *TCodesX;
    TSmallintField *TCodesY;
    TSmallintField *TCodesW;
    TSmallintField *TCodesH;
    TTable *TConstants;
    TStringField *TConstantsName;
    TStringField *TConstantsValue;
    TStringField *TConstantsDescription;
    TSmallintField *TRemotesRemote;
    TStringField *TRemotesCaption;
    TStringField *TRemotesName;
    TSmallintField *TRemotesProtocol;
    TStringField *TRemotesImage;
private:
public:
    __fastcall TData(TComponent* Owner);
};

extern PACKAGE TData *Data;
#endif
