/*
 * name: global.h
 * description: global variables and definitions of project
 * author: tilm an jochems
 * (c)10/2004, midi-formatique, rivesaltes
 */

#ifndef GlobalH
#define GlobalH
#include <syncobjs.hpp>

#define DEBUG          0               //0: definitif version
                                       //debug versions:
                                       //1: version with x-tra info

#define COM                            //use RS232
//#define PIO                            //use pio card (for MFJ only)
#define DATADIR        "../data"       //base dir of data base

//critical section object for multithread synchronization
extern TCriticalSection *CSection;
#define ECS if(CSection!=NULL)CSection->Enter();
#define LCS if(CSection!=NULL)CSection->Leave();

//some new types
typedef unsigned char    uchar;        //unsigned 8 bit
typedef unsigned short   ushort;       //unsigned 16 bit
typedef unsigned int     uint;         //unsigned 32 bit
typedef unsigned long    ulong;        //unsigned 32 bit

typedef __int64          int64;        //signed 64 bit
typedef unsigned __int64 uint64;       //unsigned 64 bit

//substraction with turn arounds
#define SHORTM(a,b)   (ushort)((ushort)(a) >= (ushort)(b) ? \
                               (ushort)(a) - (ushort)(b) : \
                               (ushort)(a) + (ushort)~(b) + 1)
#define INTM(a,b)     (uint)  ((uint)(a) >= (uint)(b) ? \
                               (uint)(a) - (uint)(b) : \
                               (uint)(a) + (uint)~(b)   + 1)
#define INT64M(a,b)   (uint64)((uint64)(a) >= (uint64)(b) ? \
                               (uint64)(a) - (uint64)(b) : \
                               (uint64)(a) + (uint64)~(b)   + 1)

#endif




