/*
 * name: mdialog.h
 * description: main dialog window
 * author: tilman jochems
 * (c)11/2004, midi-formatique, rivesaltes
 */
#ifndef MDialogH
#define MDialogH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Chart.hpp>
#include <Series.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <Buttons.hpp>
#include "Global.h"
#include "MessQueue.h"

//messages handled by thread
#define MDIALOG_NRHANDLERS    0        //number of messages

#define MESSAGESIZE          80        //size of text message


//main dialog class
class TFMDialog : public TForm
{
__published:
    TImage *IRemote;
    TSpeedButton *SB0;
    TLabel *LMessage;
    TTimer *TTest;
    TSpeedButton *SB1;
    TSpeedButton *SB2;
    TSpeedButton *SB3;
    TSpeedButton *SB4;
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormHide(TObject *Sender);
    void __fastcall IRemoteMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall SBClick(TObject *Sender);
    void __fastcall IRemoteMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall IRemoteMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall TTestTimer(TObject *Sender);
private:
    int  NrRem;                        //nr of remotes
    TSpeedButton *SBRem[5];            //remotes
    int  ActRem;                       //actual remote control
    int  OffsetX;                      //offset to image
    int  OffsetY;
    bool MouseIn;                      //mouse over button
    bool KeyDown;                      //key pressed
    int  Protocol;                     //protocol, address & code for sending
    int  Address;
    int  Code;
    void DrawButton(int,int,int,int,int,TColor,bool);
    void IdleHandler();                //execute when idle
protected:
    void __fastcall Execute(TObject*,bool&); //main loop of thread

public:
    TMessQueue *MQueue;               //message queue

    __fastcall TFMDialog(TComponent*); //construction
    __fastcall ~TFMDialog();           //destruction
};//TFMDialog

extern PACKAGE TFMDialog *FMDialog;
#endif
