/*
 * name: messqueue.h
 * description: message queue (send, post, get, dispatch,...)
 * author: tilman jochems
 * (c)10/2004, midi-formatique, rivesaltes
 */
#ifndef MessQueueH
#define MessQueueH
#include "Global.h"
#include <syncobjs.hpp>

//callback of a message
typedef int(*MQ_CALLBACK)(int arg1,int arg2);

//structure of a message
typedef struct {
 int nr;
 int  arg1;
 int  arg2;
 bool send;
 int  *res;
 HANDLE event; } MQ_MSG;


class TMessQueue{
 private:
  MQ_MSG *Queue;                       //message queue
  int QSize;                           //size of message queue (static)
  int QReadPos,QWritePos;              //pointer on read/write end
  bool QEmpty();                       //test if queue is empty
  MQ_MSG QRead();                      //read message
  void QWrite(MQ_MSG);                 //write message

  MQ_CALLBACK *Handlers;               //table of callbacks
  int HSize;                           //number of callbacks

public:
  //message handlers
  void AddHandler(int,MQ_CALLBACK);    //add a message handler
  void Dispatch(MQ_MSG);               //dispatch message

  int  Send(int,int,int);              //send a message and wait for execution
  void Post(int,int,int);              //post a message
  bool Get(MQ_MSG*,uint);              //get message from queue

  TMessQueue(int,int);                 //construction
  ~TMessQueue();                       //destruction
};//TMessQueue
#endif
