/*
 * name: tools.cpp
 * description: common used utility functions
 * author: tilman jochems
 * company: midi-formatique
 * (c)06/2004, mfj, rivesaltes
 */

#include <vcl.h>
#pragma hdrstop
#include <stdlib.h>
#include "MDialog.h"
#include "Tools.h"

/*
 * error handling
 */
//fatal error in applicaiton
void FatalError(char *str){
 MessageBox(NULL,str,"Fatal Error !",
            MB_OK | MB_TOPMOST);
 exit(1);                              //will this work ?
}//FatalError

//not fatal error in applicaiton
void NotFatalError(char *str){
 MessageBox(NULL,str,"Fatal Error !",
            MB_OK | MB_TOPMOST);
}//NotFatalError

/*
 * performance counter
 */

uint64 PCntFreq;                      //frequency of counter

//initialize counter
bool PCntInit(){
 return (QueryPerformanceFrequency((LARGE_INTEGER *)&PCntFreq) ||
         PCntFreq==0);
}//PCntInit

//get actuel tick count
uint64 PCntTicks(){
 uint64 ui;
 QueryPerformanceCounter((LARGE_INTEGER *)&ui);
 return ui;
}//PCntTicks

//get difference (in us) between actuel and given time
uint PCntDiff(uint64 time){
 uint64 ui;
 QueryPerformanceCounter((LARGE_INTEGER *)&ui);
 return (uint)(INT64M(ui,time)*1000000/PCntFreq);
}//PCntGet

/*
 * inport and outport function with win32
 * from Wenderson Teixeira (news group winapi)
 */
void  outp(ushort port, uchar byte)
{
#if DEBUG==0 || DEBUG==1 || DEBUG==2
    _DX = port;
    _AL = byte;
    __emit__(0x66, 0xee); /*out dx,al*/
#endif
}

void  outpw(ushort port, ushort word)
{
#if DEBUG==0 || DEBUG==1 || DEBUG==2
    _DX = port;
    _AX = word;
    __emit__(0x66, 0xef);/*out dx,ax*/
#endif
}

uchar  inp(ushort port)
{
#if DEBUG==0 || DEBUG==1 || DEBUG==2
    _DX = port;
    __emit__(0x66, 0xec);/*in al.dx*/
    return _AL;
#else
    return 0;
#endif
}

ushort  inpw(ushort port)
{
#if DEBUG==0 || DEBUG==1 || DEBUG==2
    _DX = port;
    __emit__(0x66, 0xed);/*in ax,dx*/
    return _AX;
#else
    return 0;
#endif
}

