/*
 * name: tools.h
 * description: common used utility functions
 * author: tilman jochems
 * company: midi-formatique
 * (c)06/2004, mfj, rivesaltes
 */
#ifndef ToolsH
#define ToolsH

#include "Global.h"

//error handling
void FatalError(char *str);            //show error and stop application
void NotFatalError(char *str);         //show error and continue

//performance counter
bool PCntInit();                       //initialize
uint64 PCntTicks();                    //get tick count of perfomance counter
uint PCntDiff(uint64 time);            //get difference with actual time

//inport/outport
uchar  inp(ushort);
ushort inpw(ushort);
void outp(ushort, uchar);
void outpw(ushort, ushort);
#endif
