/*
 * name: transmitter.cpp
 * description: transmitting remote control commands
 * author: tilman jochems
 * (c)11/2004, midi-formatique, rivesaltes
 */
#ifndef TransmitterH
#define TransmitterH
#include <Classes.hpp>
#include "Global.h"
#include "MessQueue.h"

//message functions
#define TRANSMITTER_COMSEND         0  //start/stop sending
#define TRANSMITTER_SETPROTO        1  //change protocol
#define TRANSMITTER_STARTDRV        2  //start driver
#define TRANSMITTER_NRHANDLERS      3  //number of messages

//protocols
#define PROTO_RC5                   0
#define PROTO_GRUNDIG               1
#define PROTO_YAMAHA                2

//class declaration
class TTransmitter : public TThread
{
private:
 //variables/ functions for all codes
 int Protocol;                         //actuel protocol
 bool Sending;                         //sending on/off
 bool Toggle;                          //toggle bit
 int  Address;                         //address to send
 int  Code;                            //code to send
 uint64 SendTime;                      //time of sending of last frame
 void SendBits(int *,int,float,uint);  //send bits to output

 //protocol functions
 void Rc5Send();
 void GruSend(bool =false);
 void YamSend(bool =false);

 //message handlers
 static int ComSend(int,int);          //command sending
 static int SetProto(int,int);         //set protocol
 static int StartDrv(int,int);         //start driver

protected:
 void __fastcall Execute();            //main loop of thread

public:
 TMessQueue *MQueue;                   //message queue
 __fastcall TTransmitter(bool);            //construction
 __fastcall ~TTransmitter();               //destruction
};//TTransmitter

extern TTransmitter *Transmitter;
#endif
